const path = require('path')
const rra = require('recursive-readdir-async')
const dir = path.resolve(_flitter.directories.config)

exports.up = async ({flap}) => {

    const files = await rra.list(dir)
    for ( let key in files ){
        await flap.find_replace_file(files[key].fullname, /process\.env\.(?:\s*\|\|\s*|[^\s^,])*/g, '%orig', (match) => {
            const parts = match.split('||')
            const env_name = parts[0].replace('process.env.', '').trim()
            let env_call = `env("${env_name}"`
            
            if ( parts.length > 1 ) env_call += `, ${parts[1].trim()}`
            
            env_call += ')'
            
            return env_call
        })
    }
}

exports.down = async ({flap}) => {
    
    const files = await rra.list(dir)
    for ( let key in files ){
        await flap.find_replace_file(files[key].fullname, /env\(.*\)[^,^\n]?/g, '%orig', (match) => {
            const parts = match.match(/(?:'.*?'|".*?")[^,^\)]?/g)
            const env_name = parts[0].replace(/['"]/g, '').trim()
            let env_call = 'process.env.'+env_name
            
            if ( parts.length > 1 ) env_call += ' || '+parts[1].trim()
            
            return env_call
        })
    }

}
